Optimal Account Balancing

A group of friends went on holiday and sometimes lent each other money. For example, Alice paid for Bill's lunch for $10. Then later Chris gave Alice $5 for a taxi ride. We can model each transaction as a tuple (x, y, z) which means person x gave person y $z. Assuming Alice, Bill, and Chris are person 0, 1, and 2 respectively (0, 1, 2 are the person's ID), the transactions can be represented as [[0, 1, 10], [2, 0, 5]].

Given a list of transactions between a group of people, return the minimum number of transactions required to settle the debt.

Note:

  1. A transaction will be given as a tuple (x, y, z). Note that x ≠ y and z > 0.
  2. Person's IDs may not be linear, e.g. we could have the persons 0, 1, 2 or we could also have the persons 0, 2, 6.

Example 1:

Input:
[[0,1,10], [2,0,5]]

Output:
2

Explanation:
Person #0 gave person #1 $10.
Person #2 gave person #0 $5.

Two transactions are needed. One way to settle the debt is person #1 pays person #0 and #2 $5 each.

思路: 统计出+,-之后,把所有不是0的变量全部收集起来,然后做backtracking,用一个正数去抵消一个负数,然后继续进行,统计全局最小txn,即可;注意的是,dfs expore的时候,是start+1,不是i,因为有正负数,i前面有可能有没有处理完的数,所以只能从start + 1开始;

T: O(N!) , since T(n) = n * T(n - 1);

class Solution {
    public int minTransfers(int[][] transactions) {
        HashMap hashmap = new HashMap<>();
        for(int[] transaction: transactions) {
            int from = transaction[0];
            int to = transaction[1];
            int money = transaction[2];
            // from -> to money;
            hashmap.put(from, hashmap.getOrDefault(from, 0) - money);
            hashmap.put(to, hashmap.getOrDefault(to, 0) + money);
        }
        
        ArrayList list = new ArrayList(hashmap.values());
        return dfs(list, 0);
    }
    
    private int dfs(ArrayList list, int start) {
        while(start < list.size() && list.get(start) == 0) {
            start++;
        }
        if(start == list.size()) {
            return 0;
        }
        int minvalue = Integer.MAX_VALUE;
        for(int i = start + 1; i < list.size(); i++) {
            if(list.get(start) * list.get(i) < 0) {
                list.set(i, list.get(i) + list.get(start));
                // 注意这里是start + 1,  不是i, 因为里面有正负号,i前面有可能没处理完;
                // 所以只能从start + 1开始;
                minvalue = Math.min(minvalue, 1 + dfs(list, start + 1));
                list.set(i, list.get(i) - list.get(start));
            }
        }
        return minvalue;
    }
}

你可能感兴趣的:(BackTracking,leetcode)